package com.dcs.hnyz.service;

import com.dcs.hnyz.domain.Equipment;
import com.dcs.hnyz.domain.vo.EquipmentFormVO;

import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * 设备管理Service接口
 * 
 * @author hmy
 * @date 2025-04-22
 */
public interface IEquipmentService 
{
    /**
     * 查询设备管理
     * 
     * @param equipmentId 设备管理主键
     * @return 设备管理
     */
    public Equipment selectEquipmentByEquipmentId(Long equipmentId);

    /**
     * 查询设备管理列表
     * 
     * @param equipment 设备管理
     * @return 设备管理集合
     */
    public List<Equipment> selectEquipmentList(Equipment equipment);

    /**
     * 查询设备管理列表
     * @param equipment
     * @return
     */
    public List<EquipmentFormVO> selectEquipmentForm(Equipment equipment);


    /**
     * 新增设备管理
     * 
     * @param equipment 设备管理
     * @return 结果
     */
    public int insertEquipment(Equipment equipment);

    /**
     * 修改设备管理
     * 
     * @param equipment 设备管理
     * @return 结果
     */
    public int updateEquipment(Equipment equipment);

    int updateEquipmentByPlcId(Long plcId);

    /**
     * 批量删除设备管理
     * 
     * @param equipmentIds 需要删除的设备管理主键集合
     * @return 结果
     */
    public int deleteEquipmentByEquipmentIds(Long[] equipmentIds);

    /**
     * 删除设备管理信息
     * 
     * @param equipmentId 设备管理主键
     * @return 结果
     */
    public int deleteEquipmentByEquipmentId(Long equipmentId);

    /**
     * 获取设备名称列表(树状)
     * @param dataType
     * @return
     */
    List<Map<String,Object>> getEquipmentNameList(String dataType);

    /**
     * 获取传感器相关的设备类型列表
     * @return
     */
    List<Map<String,Object>> getEquipmentSensorTree();

    /**
     * 获取首页顶部区域的统计数据
     * @return
     */
    Map<String,Object> getDashboardStats();

    /**
     * 根据设备id集合获取设备信息
     * @param equipmentIds
     * @return
     */
    Map<Long, Equipment> getByIds(Set<Long> equipmentIds);

    /**
     * 根据设备code查询设备
     * @param code
     * @return
     */
    Equipment getEquipmentByCode(String code);

    int updateStatus(Equipment equipment);

    /**
     * 根据流程编码获取设备组信息
     * @param flowCode
     * @return
     */
    Map<String,List<Equipment>> getPageEquipmentGroupByFlowCode(String flowCode);

    String importEquipment(List<Equipment> equipmentList, boolean updateSupport, String operName);

    /**
     * 根据流程编码按罐体设备分组 获取设备组信息
     * @param flowCode
     * @return
     */
    Map<String,List<Equipment>> getPageEquipmentGroupByTankByFlowCode(String flowCode);

    /**
     * 获取设备code->设备id的映射
     */
    Map<String, Long> getEquipmentIdCodeMap();
}
